config/routes.rb
Rails.application.routes.draw do

  root to: 'home#index'

  devise_for :users, controllers: {
    registrations: 'users/registrations',
    passwords:     'users/passwords',
    sessions:      'users/sessions',
  }

  namespace :admin do
    resources :users, only: [:index]
    get '/evaluation', to: 'users#evaluation'
  end

  resources :users do
    member do
      post :details
      get :details, to: 'users#show'
      get :evaluations, to: 'users#evaluations'
    end
    collection do
      get :manual, to: 'users#manual'
    end
  end

  delete "attachements/:id/purge", to: "attachments#purge", as: "purge_attachment"
  
  resources :evaluations, only: [:index, :new, :create]
end

app/models/user.rb
class User < ApplicationRecord
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  validates :name, presence: true, length: { maximum: 50 }
  validates :character, length: { maximum: 50 }
  validates :hobby, length: { maximum: 50 }
  validates :image, 
    content_type: [:png, :jpg, :jpeg, :heic],
    size: { less_than_or_equal_to: 5.megabytes }
  validates :sub_images, 
    content_type: [:png, :jpg, :jpeg, :heic],
    size: { less_than_or_equal_to: 5.megabytes }

  FILE_NUMBER_LIMIT = 3
  validate :validate_number_of_sub_images

  has_many :evaluations, dependent: :destroy
  has_one_attached :image
  has_many_attached :sub_images

  private

  def validate_number_of_sub_images
    return if sub_images.length <= FILE_NUMBER_LIMIT
    errors.add(:sub_images, "に添付できる画像は#{FILE_NUMBER_LIMIT}件までです。")
  end
end

app/controllers/admin/users_controller.rb
class Admin::UsersController < ApplicationController
  before_action :require_admin

  def index
    @q = User.all.ransack(params[:q])
    @users = @q.result(distinct: true).order('updated_at DESC').paginate(page: params[:page], per_page: 6)
    @male = User.where(sex: 1)
    @female = User.where(sex: 0)
  end

  def evaluation
    @evaluations = Evaluation.includes(:user).order('created_at DESC').paginate(page: params[:page], per_page: 8)
  end

  private

  def require_admin
    redirect_to root_path unless current_user.admin?
  end

end

app/controllers/users/confirmations_controller.rb
# frozen_string_literal: true

class Users::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

app/controllers/users/omniauth_callbacks_controller.rb
# frozen_string_literal: true

class Users::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/heartcombo/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end
end

app/controllers/users/passwords_controller.rb
# frozen_string_literal: true

class Users::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

app/controllers/users/registrations_controller.rb
# frozen_string_literal: true

class Users::RegistrationsController < Devise::RegistrationsController
  # before_action :configure_sign_up_params, only: [:create]
  # before_action :configure_account_update_params, only: [:update]

  # GET /resource/sign_up
  # def new
  #   super
  # end

  # POST /resource
  # def create
  #   super
  # end

  # GET /resource/edit
  # def edit
  #   super
  # end

  # PUT /resource
  # def update
  #   super
  # end

  # DELETE /resource
  # def destroy
  #   super
  # end

  # GET /resource/cancel
  # Forces the session data which is usually expired after sign
  # in to be expired now. This is useful if the user wants to
  # cancel oauth signing in/up in the middle of the process,
  # removing all OAuth session data.
  # def cancel
  #   super
  # end

  protected

  def after_update_path_for(resource)
    user_path(current_user)
  end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_up_params
  #   devise_parameter_sanitizer.permit(:sign_up, keys: [:attribute])
  # end

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_account_update_params
  #   devise_parameter_sanitizer.permit(:account_update, keys: [:attribute])
  # end

  # The path used after sign up.
  # def after_sign_up_path_for(resource)
  #   super(resource)
  # end

  # The path used after sign up for inactive accounts.
  # def after_inactive_sign_up_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users/sessions_controller.rb
# frozen_string_literal: true

class Users::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # def after_sign_in_path_for(resource)
  #   users_path 
  # end
  
  # def after_sign_out_path_for(resource)
  #   root_url
  # end
  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/users/unlocks_controller.rb
# frozen_string_literal: true

class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :authenticate_user!
  before_action :set_user, only: [:show, :edit, :update, :destroy, :evaluations, :correct_user, :purge_image]

  def index
    @users = User.order("RANDOM()").all
  end

  def show
    @evaluations = Evaluation.where(evaluatee_id: @user.id).includes(:user)
  end

  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    if @user.save
      redirect_to @user, notice: "「#{@user.name}」さんを新規登録しました。"
    else
      render :new
    end
  end

  def edit
  end

  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: "「#{@user.name}」さんはプロフィールを更新しました。" }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @user.destroy
    redirect_to users_url, notice: "「#{@user.name}」さんは退会しました。"
  end

  def details
    @user = User.find(params[:user_id])
    lose_point
    flash[:notice] = "3ポイント消化。(所持ポイント#{@point})"
  end

  def evaluations
    @evaluations = Evaluation.where(evaluatee_id: current_user.id).order('created_at DESC')
  end

  def manual
  end

  def purge_image
    @user.image.purge
    redirect_back fallback_location: user_path(@user), notice: "画像は削除されました。"
  end

  private

  def user_params
    params.require(:user).permit(:name, :email, :admin, :password, :sex, :character, :hobby, :generation, :point, :image, sub_images: [])
  end

  def set_user
    @user = User.find(params[:id])
  end

  def correct_user
    redirect_to(root_url) unless @user == current_user || current_user.admin?
  end

  def lose_point
    @point = current_user.point
    if @point > 3
      @point -= 3
    else
      @point = 0
    end
    current_user.update!(point: @point)
  end
end

app/helpers/admin/users_helper.rb
module Admin::UsersHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/users/_form.html.erb
<% if @user.errors %>
  <ul id="error_explanation">
    <% user.errors.full_messages.each do |message| %>
      <li class="text-danger"><%= message %></li>
    <% end %>
  </ul>
<% end %>
<span class="small text-danger">※は必須項目</span>
<%= form_with model: @user, class: "mx-3", local: true do |f| %>
  <table class="table table-hover shadow-sm">
    <tbody>
      <tr>
        <th><%= f.label :name, 'ニックネーム', class: "text-muted" %><span class="small text-danger">※</span></th>
        <td><%= f.text_field :name, autofocus: true, class: "form-control" %></td>
      </tr>
      <tr>
        <th><%= f.label :email, 'メールアドレス', class: "text-muted" %><span class="small text-danger">※</span></th>
        <td><%= f.email_field :email, class: "form-control" %></td>
      </tr>
      <tr>
        <th><%= f.label :password, 'パスワード', class: "text-muted" %><span class="small text-danger">※</span></th>
        <td><%= f.password_field :password, class: "form-control" %></td>
      </tr>
      <tr>
        <th><%= f.label :password_confirmation, 'パスワード（確認）', class: "text-muted" %><span class="small text-danger">※</span></th>
        <td><%= f.password_field :password_confirmation, class: "form-control" %></td>
      </tr>
      <tr>
        <th><%= f.label :sex, '性別', class: "text-muted" %><span class="small text-danger">※</span></th>
        <td><%= f.select :sex, [['女性', 0], ['男性', 1]], {}, { id: "sex", class: "form-control" } %></td>
      </tr>
      <tr>
        <th><%= f.label :hobby, '趣味', class: "text-muted" %></th>
        <td><%= f.text_field :hobby, class: "form-control" %></td>
      </tr>
      <tr>
        <th><%= f.label :character, '性格', class: "text-muted" %></th>
        <td><%= f.text_field :character, class: "form-control" %></td>
      </tr>
      <tr>
        <th><%= f.label :generation, '世代', class: "text-muted" %><span class="small text-danger">※</span></th>
        <td><%= f.select :generation, [['10代', 0], ['20代', 1], ['30代', 2],['40代', 3],['50代', 4],['60代以上', 5]],{}, { id: "generation", class: "form-control" } %></td>
      </tr>
      <tr>
        <th><%= f.label :image, 'トップ画像', class: "text-muted" %><span class="small text-danger">※</span></th>
        <td>
          <%= f.file_field :image, class: "form-control" %>
          <% if user.image.attached? %>
            <div class="d-flex justify-content-start mt-2">
              <%= image_tag user.image.variant(resize: "30x30"), class:'px-2' %><span class="small">選択画像</span>
            </div>
          <% else %>
            <span class="small">画像がありません。</span>
          <% end %>
        </td>
      </tr>
      <tr>
        <th><%= f.label :sub_images, 'サブ画像', class: "text-muted" %><br /><span class="small text-danger">(サブ画像は２枚まで選択可)</span></th>
        <td>
          <%= f.file_field :sub_images, multiple: true, class: "form-control" %>
          <% if user.sub_images.attached? %>
            <div class="d-flex justify-content-start mt-2">
              <% @user.sub_images.each do |sub_image| %>
                <%= f.check_box :sub_image_ids, { multiple: true }, sub_image.id, false %>
                <label for="user_sub_image_ids_<%= sub_image.id %>">
                  <%= image_tag sub_image.variant(resize: "30x30"), class:'px-2' %>
                </label>
              <% end %>
              <p class="small">選択画像(※削除する画像にチェックをつけてください)</p>
            </div>
          <% else %>
            <span class="small">画像がありません。</span>
          <% end %>
        </td>
      </tr>
    </tbody>
  </table> 
  <div class="text-center">
    <%= f.submit '登録する', class: "btn btn-info rounded-pill" %>
  </div>
<% end %>

app/views/users/_impression.html.erb
<div class="card-deck justify-content-center">

  <div class="card-prof border py-5 px-3 mt-4">
    <p>
      <i class="fa-solid fa-chart-simple fa-3x text-deepred"></i>
    </p>
    <h3 class="text-deepred py-3">- <%= @user.name %>さんの印象 -</h3>
    <p class="lead font-weight-bold">Total</p>
    <div class="display-3 font-weight-bold text-deepred">
      <%= impression_total %>
    </div><small>/100</small>
    <p class="text-danger lead font-weight-bold mt-2"><%= impression_comment(@user.sex) %></p>
    <p class="mt-2 lead text-secondary">（<%= @evaluations.count %>人に評価されました！）</p>
  </div>

  <div class="card-prof border py-5 px-3 mt-4">
    <p>
      <i class="fa-solid fa-user-group fa-3x text-info"></i>
    </p>
    <h3 class="text-info pt-3 pb-5">- 世代別支持率 -</h3>
    <% for num in 0..5 do %>
      <p class="lead text-info text-left">
        <span class="font-weight-bold"><%= num + 1 %>0代:</span>　<%= impression_graph(num) %>（<%= impression_each_generation(num) %>）
      </p>
    <% end %>
  </div>

  <div class="card-prof border py-5 px-3 mt-4">
    <p>
      <i class="fa-solid fa-venus-mars fa-3x text-orange"></i>
    </p>
    <h3 class="text-orange py-3">- 性別別支持率 -</h3>
    <% for num in 0..1 do %>
      <i class="fa-solid fa-2x text-orange my-3
        <% if num==0 %>
         fa-venus
        <% else %>
         fa-mars
        <% end %>">
      </i>
      <p class="lead text-orange text-left">
        <span class="font-weight-bold"><%= num==0?'女':'男' %>性:</span>　<%= impression_graph_gender(num) %>（<%= impression_each_gender(num) %>）
        <br />
        <small class="text-secondary ml-4 pl-4">
          (<%= num==0?'女':'男' %>性<%= evaluation_count(num) %>人に評価されました)
        </small>
      </p>
    <% end %>
  </div>
</div>
<% if current_user.id == @user.id %>
  <p class="text-center lead mt-4">
    <%= link_to evaluations_user_path(current_user), class: "button02 font-weight-bold" do %>
      <i class="fa-solid fa-face-smile"></i> 自分を評価した人を見る<br />
    <% end %><br />
  </p>
<% end %>

app/views/users/_sub_pic.html.erb
<% if @user.sub_images.attached? %>
  <div class="text-divider font-weight-bold text-dark pb-4">サブ画像</div>
  <div id="carouselExampleControls" class="carousel slide" data-interval="false" data-ride="carousel">
    <div class="carousel-inner">
      <% if @user.sub_images[1] %>
        <% @user.sub_images.first(1).each do |attachment| %>
          <div class="carousel-item active">
            <%= image_tag attachment.variant(resize: "300x400"), class: 'rounded border mx-2 mb-3' %>
            <% if current_user.id == @user.id %>
              <p class="small"><%= link_to "▲画像削除", purge_attachment_path(attachment), class: "btn-light btn-sm rounded-pill", method: :delete,  data: { confirm: "「画像を削除します。よろしいですか？"} %></p>
            <% end %>
          </div>
        <% end %>
        <% @user.sub_images.drop(1).each do |attachment| %>
          <div class="carousel-item">
            <%= image_tag attachment.variant(resize: "300x400"), class: 'rounded border mx-2 mb-3' %>
            <% if current_user.id == @user.id %>
              <p class="small"><%= link_to "▲画像削除", purge_attachment_path(attachment), class: "btn-light btn-sm rounded-pill", method: :delete,  data: { confirm: "「画像を削除します。よろしいですか？"} %></p>
            <% end %>
          </div>
        <% end %>
        <a class="carousel-control-prev" href="#carouselExampleControls" role="button" data-slide="prev">
          <span class="carousel-control-prev-icon" aria-hidden="true"></span>
          <span class="sr-only">Previous</span>
        </a>
        <a class="carousel-control-next" href="#carouselExampleControls" role="button" data-slide="next">
          <span class="carousel-control-next-icon" aria-hidden="true"></span>
          <span class="sr-only">Next</span>
        </a>
      <% else %>
        <% @user.sub_images.first(1).each do |attachment| %>
          <div class="carousel-item active">
            <%= image_tag attachment.variant(resize: "300x400"), class: 'rounded border mx-2 mb-3' %>
            <% if current_user.id == @user.id %>
              <p class="small"><%= link_to "▲画像削除", purge_attachment_path(attachment), class: "btn-light btn-sm rounded-pill", method: :delete,  data: { confirm: "「画像を削除します。よろしいですか？"} %></p>
            <% end %>
          </div>
        <% end %>
      <% end %>
    </div>
  </div>
<% end %>

app/views/users/details.html.erb
<% provide(:title, "#{@user.name}さんプロフィール") %>

<div class="d-flex justify-content-center">
  <div class="card-prof mb-5">
    <% if @user.image.attached? %>
      <%= image_tag @user.image, class: 'card-prof-img', alt: 'Card image cap' %>
    <% else %>
      <%=image_tag "default_profile_img.png", class: 'card-prof-img',alt: 'Card image cap' %>
    <% end %>
    <p class="lead pt-3"><%= yield(:title) %></p>
    <div class="card-prof-content text-wine">
      <div class="text-divider font-weight-bold text-dark pb-4">基本情報</div>
      <p><span class="small text-dark"><%= User.human_attribute_name(:hobby) %>：　</span><%= @user.hobby %></p>
      <p><span class="small text-dark"><%= User.human_attribute_name(:character) %>：　</span><%= @user.character %></p>
      <p><span class="small text-dark"><%= User.human_attribute_name(:sex) %>：　</span><%= set_sex(@user) %></p>
      <p><span class="small text-dark"><%= User.human_attribute_name(:generation) %>：　</span><%= set_generation(@user) %></p>
      <%# サブ画像ブロック %>
      <%= render "sub_pic" %>
    </div>
    
  </div>
</div>

<%# 印象ブロック %>
<%= render "impression" %>
<p class="lead font-weight-bold mt-4">
  <i class="fa-solid fa-arrow-rotate-left text-info"></i><br />
  <%= link_to "前へ戻る", :back, class: "text-info" %>
</p>

app/views/users/edit.html.erb
<% provide(:title, "プロフィールの編集") %>

<p class="lead"><%= yield(:title) %></p>

<%= render partial: 'form', locals: { user: @user } %>

app/views/users/evaluations.html.erb
<% provide(:title, "評価一覧") %>

<% if @evaluations.count == 0 %>
    <p class="lead text-info mt-5 pt-5">まだだれからも評価がありません。</p>
    <p class="px-4">こちらからどんどん評価していくと相手から評価されやすくまたポイントも貯まります！</p>
<% else %>
<div class="mx-3">
    <table class="table table-hover bg-white shadow-sm my-3">
        <thead class="thead-default bg-light">
            <tr class="text-center">
                <th>評価した人</th>
                <th>評価点</th>
                <th>評価した人の性格</th>
                <th>評価した人の趣味</th>
            </tr>
        </thead>
        <tbody>
        <% @evaluations.each do |eval| %>
            <tr class="text-left">
                <td>
                    <% if eval.user.image.attached? %>
                        <%= image_tag eval.user.image, width:30, class: 'rounded-circle' %>
                    <% else %>
                        <%=image_tag "default_profile_img.png", width:30, class: 'rounded-circle' %>
                    <% end %>
                    <%= link_to "#{eval.user.name}", user_path(eval.user_id), class: 'text-info' %>
                </td>
                <td><%= eval.evaluation_point %>pts</td>
                <td><%= eval.user.character %></td>
                <td><%= eval.user.hobby %></td>
            </tr>
        <% end %>    
        </tbody>
    </table>    
</div>
<% end %>

app/views/users/index.html.erb
<% provide(:title, "スカウター一覧") %>

<% if current_user.point < 3 %>
  <p class="mb-5">
    まずは3人を評価して<b class="text-wine">3ポイントゲット</b>しよう！<br /><b class="text-wine">３ポイントたまったら</b>興味のある人の評価をのぞいてみよう！
  </p>
<% else %>
  <p class="mb-5"><b class="text-info">３ポイント消化</b>で気になる相手の評価がのぞける！</p>
<% end %>
<div class="card-group-x justify-content-center">
  <% @users.each do |user| %>
    <% if user.image.attached? %>
      <div class="card-x">
        <div class="card__imgframe-x">
          <%= link_to user_path(user) do %>
            <%= image_tag user.image, class:'img-list border border-dark' %>
          <% end %>
        </div>
        <div class="card__textbox-x">
          <p>
            <%= link_to "プロフィール", user_path(user), class: "btn btn-border small" %>
          </p>
        </div>
      </div>
    <% end %>
  <% end %>
</div>

app/views/users/manual.html.erb
<% provide(:title, "スカウターマニュアル") %>

<h2 class="display-3 font-weight-bold mt-5">使い方</h2>
<p class="lead font-weight-bold text-danger">How To Use</p>
<p class="lead font-weight-bold">使い方はカンタン。</p>

<p>
<%= image_tag 'cell_phone.jpg', size: '320x240', class: 'rounded-circle my-4' %>
</p>
<i class="fa-solid fa-1 text-wine display-4 pb-3"></i>
<p class="lead px-5">だれかが自分の評価をすると自分の印象がわかる！</p>
<i class="fa-solid fa-2 text-wine display-4 pb-3"></i>
<p class="lead px-5">一人評価するごとに<span class="font-weight-bold text-danger">「1ポイント」</span>がたまる！</p>
<i class="fa-solid fa-3 text-wine display-4 pb-3"></i>
<p class="lead px-5"> <span class="font-weight-bold text-danger">「3ポイント」</span>たまると気になる人の評価をのぞくことができる！<br /><small>（<span class="text-danger">※</span> 所持ポイント3ポイント以上で「評価ボタン」が現れます）</small></p>

<div class="card-deck text-center pt-3 pb-1 my-5">
  <div class="card mb-4 border-0">
    <div class="card-body">
      <%= image_tag 'top_sub_1.png', width: '100%', class: 'border border-secondary rounded' %>
    </div>
    <div class="card-body">
      <p class="btn btn-sm btn-info w-50 rounded-pill">STEP 1</p>
      <p class="text-left mt-3 mb-4">
          まずはどんどん評価していてポイントをためていこう！　　　　　　　　　　　　　
      </p>
    </div>
  </div>
  <div class="card mb-4 border-0">
    <div class="card-body">
      <%= image_tag 'top_sub_2.png', width: '100%', class: 'border border-secondary rounded' %>
    </div>
    <div class="card-body">
      <p class="btn btn-sm btn-info w-50 rounded-pill">STEP 2</p>
      <p class="text-left mt-3 mb-4">
          所持ポイントが<span class="font-weight-bold text-danger">「3ポイント」</span>以上になると気になる人の評価をのぞける！
      </p>
    </div>
  </div>
  <div class="card mb-4 border-0">
    <div class="card-body">
      <%= image_tag 'top_sub_3.png', width: '100%', class: 'border border-secondary rounded' %>
    </div>
    <div class="card-body">
      <p class="btn btn-sm btn-info w-50 rounded-pill">STEP 3</p>
      <p class="text-left mt-3 mb-4">
          相手が評価してくれるとマイページから自分の評価を確認できる！　　　　　　　　　
      </p>
    </div>
  </div>
</div>

app/views/users/new.html.erb
<% provide(:title, "まずはプロフィールを作成！") %>

<p class="lead mt-5 mb-3"><%= yield(:title) %></p>

<%= render partial: 'form', locals: { user: @user } %>

app/views/users/show.html.erb
<% provide(:title, "#{@user.name}") %>


<% if current_user.id == @user.id %>
  <% unless @user.image.attached? %>
  <p class="mb-2">まずは<b class="text-wine">トップ画像</b>を変えましょう！</p>
  <p class="mb-3"><%= link_to "画像変更", edit_user_registration_path, class: "btn-info btn-sm rounded-pill"  %></p>
  <% end %>
<% end %>

<div class="d-flex justify-content-center">
  <div class="card-prof mb-2">
    <% if @user.image.attached? %>
      <%= image_tag @user.image, class: 'card-prof-img', alt: 'Card image cap' %>
    <% else %>
      <%=image_tag "default_profile_img.png", class: 'card-prof-img',alt: 'Card image cap' %>
    <% end %>
    <p class="lead pt-3"><%= yield(:title) %><br />
      <span class="small text-muted">さん</small>
    </p>
    
    <div class="card-prof-content text-wine">
      <div class="text-divider font-weight-bold text-dark pb-4">基本情報</div>
      <p><span class="small text-dark"><%= User.human_attribute_name(:hobby) %>：　</span><%= @user.hobby %></p>
      <p><span class="small text-dark"><%= User.human_attribute_name(:character) %>：　</span><%= @user.character %></p>
      <% if current_user.id == @user.id || current_user.admin? %>
        <p><span class="small text-dark"><%= User.human_attribute_name(:email) %>：　</span><%= @user.email %></p>
        <p><span class="small text-dark"><%= User.human_attribute_name(:sex) %>：　</span><%= set_sex(@user) %></p>
        <p><span class="small text-dark"><%= User.human_attribute_name(:generation) %>：　</span><%= set_generation(@user) %></p>
        <p class="font-weight-bold text-dark mt-5"><%= image_tag "https://cdn.with.is/assets/shared/icons/point-13022b529ea3220c018a44897946eab5913d018375c5f482c11452b24a92b2bc.svg", width: "50" %>　<%= User.human_attribute_name(:point) %><br /><span class="display-3"><%= @user.point %></span></p>
        
      <% end %>
      <p class="mt-2 lead text-secondary">
        <% if @evaluations.count == 0 %>
        （まだ評価がありません）
        <% else %>
        （<%= @evaluations.count %>人が評価しています）
        <% end %>
      </p>
      <%# サブ画像ブロック %>
      <%= render "sub_pic" %>
      <%# プロフの編集 %>
      <% if current_user.id == @user.id %>
        <div class="text-center">
          <%= link_to edit_user_registration_path, class: "button03 mt-2" do %>
            <i class="fa-solid fa-pen-to-square"></i> プロフィール編集<br />
          <% end %><br />
        </div>
      <% end %>
    </div>
  </div>
</div>

<%# 測定ブロック %>
<% if @user.id != current_user.id %>
  <%= link_to new_evaluation_path(user_id: current_user.id, evaluatee_id: @user.id), class: "button02 mt-4" do %>
    <i class="fa-solid fa-eye lead"></i> 測定！<small>(1ポイント獲得)</small>
  <% end %>
<% end %>

<%# 3ポイント以上でプロフチェック %>
<% if current_user.point >= 3 && @user.id != current_user.id %>
  <div class="mt-4">
    <%= link_to details_user_path(user_id: @user.id), method: :post, class: "button04" do %><i class="fa-solid fa-address-card lead"></i> 評価を見る！<small>(3ポイント消化)</small><% end %>
  </div>
<% end %>

<%# 印象ブロック %>
<% if current_user.id == @user.id %>
  <%= render "impression" %>
<% end %>

<%# プロフの削除 %>
<% if current_user.id == @user.id %>
  <div class="text-center mt-4">
    <%= link_to "退会する", @user, method: :delete, data: { confirm: "「#{@user.name}」さん、本当に退会しますか？"}, class: "small text-secondary" %>
  </div>
<% end %>